
Account {
   l: Lock
   balance: AtomicRegister
}

Transfer {
   accounts: AtomicRegister[2]

   def this() {
      I1>    account1 = new Account()
      I2>    account1.balance.write(100)
      I3>    account2 = new Account()
      I4>    account2.balance.write(100)
      I5>    accounts[0].write(account1)
      I6>    accounts[1].write(account2)
   }

   def lock(no) {
      L1>    account = accounts[no].read()
      L2>    account.l.lock()
      L2>    return
   }

   def lock(no) {
      L1>    account = accounts[no].read()
      L2>    account.l.unlock()
      L2>    return
   }

   def deposit(no, amount) {
      D1>    account = accounts[no].read()
      D3>    b = account.balance.read()
      D4>    newB = b + amount
      D5>    account.balance.write(newB)
      D7>    return
   }

   def withdraw(no, amount) {
      W1>    account = accounts[no].read()
      W3>    b = account.balance.read()
      W4>    newB = b - amount
      W5>    account.balance.write(newB)
      W7>    return
   }

   def ~this() {
      UI1>    account2 = accounts[1].read()
      UI2>    v = account2.balance.read()
   }

   main {
      {
         T13>   withdraw(0, 10)
         T14>   deposit(1, 10)
      } || {
         I23>   withdraw(0, 10)
         I24>   deposit(1, 10)
      }
   }

   spec {
      v = 120
   }
}
