package speclang.spec.ast.tree.statement;

import lesani.collection.option.None;
import lesani.collection.option.Option;
import speclang.spec.ast.tree.declaration.Label;
import speclang.spec.ast.tree.expression.op.atom.Var;
import speclang.spec.ast.tree.expression.op.atom.Varl;
import speclang.spec.ast.tree.token.Id;
import speclang.spec.ast.visitor.SVisitor;


public class MethodCall extends GMethodCall {

   public MethodCall(Option<Label> label, Id obj, Id name, Varl[] args, Option<Var> retv) {
      super(label, obj, name, args, retv);
   }

   public <R> R accept(SVisitor.StatementVisitor<R> v) {
      return v.visit(this);
   }

   public Option<Label> getLabel() {
      return label;
   }

   public <S, A> S accept(SVisitor.StatementVisitorArg<S, A> v, A a) {
      return v.visit(this, a);
   }
}

